#include <stdio.h>
#include <unistd.h>

#define MAX_WIDTH 100
#define MAX_HEIGHT 100

int height, width, pos_x=0, pos_y;
// dir = Direction: 2 = nach oben, 1 = nach rechts, 0 = nach unten, 3 = nach links
int dir=0;
unsigned char labyrinth[MAX_WIDTH][MAX_HEIGHT];

void getLabyrinth() {
	int i, j;
	unsigned char line[MAX_WIDTH+1];
	scanf("%d%d\n", &width, &height);
	for (i=0; i<height; i++) {
		fgets(line,width+5,stdin);
		for (j=0; j<width; j++) {
			labyrinth[j][i]=line[j];
		}
	}
}

int getStart() {
	int i;
//	for (i=0; i<height; i++) if (labyrinth[0][i]=='S') {printf("%d 0 | ", i); return i;}
	for (i=0; i<height; i++) if (labyrinth[0][i]=='S') return i;
	return -1;
}

int getEnd() {
	int i;
	for (i=0; i<width; i++) if (labyrinth[i][0]=='E') return 0;
	for (i=0; i<height; i++) if (labyrinth[width-1][i]=='E') return 0;
	for (i=0; i<width; i++) if (labyrinth[i][height-1]=='E') return 0;
	for (i=0; i<height; i++) if (labyrinth[0][i]=='E') return 0;
	return -1;
}

/*
dir = Direction: 2 = nach oben, 1 = nach rechts, 0 = nach unten, 3 = nach links
unten -> links, unten, rechts, oben
links -> oben, links, unten, rechts
oben -> rechts, oben, links, unten
rechts -> unten, rechts, oben, links
*/
int step() {
	if (labyrinth[pos_x][pos_y]=='E') return 1;
	switch (dir) {
	case 0: if (pos_x-1>=0) if (labyrinth[pos_x-1][pos_y]!='X') {
				dir=3;
				pos_x--;
				return 0;
			}
	case 1:	if (pos_y+1<height) if (labyrinth[pos_x][pos_y+1]!='X') {
				dir=0;
				pos_y++;
				return 0;
			}
	case 2:	if (pos_x+1<width) if (labyrinth[pos_x+1][pos_y]!='X') {
				dir=1;
				pos_x++;
				return 0;
			}
	case 3:	if (pos_y-1>=0) if (labyrinth[pos_x][pos_y-1]!='X') {
				dir=2;
				pos_y--;
				return 0;
			}
			if (pos_x-1>=0) if (labyrinth[pos_x-1][pos_y]!='X') {
				dir=3;
				pos_x--;
				return 0;
			}
			if (pos_y+1<height) if (labyrinth[pos_x][pos_y+1]!='X') {
				dir=0;
				pos_y++;
				return 0;
			}
			if (pos_x+1<width) if (labyrinth[pos_x+1][pos_y]!='X') {
				dir=1;
				pos_x++;
				return 0;
			}
	}
	return -1;
}

int main () {
	int i,j;
	getLabyrinth();
	printf("\x1b[2J\x1b[1;1H\x1b[1m");
	for (i=0; i<height; i++) {
		for (j=0; j<width; j++) {
			switch (labyrinth[j][i]) {
			case 'o': printf("\x1b[40m ");
					  break;
			case 'S': printf("\x1b[40;31mS");
					  break;
			case 'E': printf("\x1b[40;31mE");
			     	  break;
			default: printf("\x1b[47m ");
			}
		}
		printf("\n");
	}
	printf("\x1b[0m");
	if ((pos_y=getStart())==-1) return 1;
	if (getEnd()==-1) return 2;
	// loslaufen
//	while (step()==0) printf("%d %d | ", pos_y, pos_x);
	while (step()==0) {
		usleep(50000);
		printf("\x1b[%d;%dH\x1b[44m \x1b[%d;%dH\x1b[42m", pos_y+1, pos_x+1, pos_y+1, pos_x+1);
		fflush(NULL);
	}
	printf("\x1b[0;37;40m\x1b[%d;1H", height+1);
	return 0;
}
